<!DOCTYPE html>
<!-- Generated by pkgdown: do not edit by hand --><html lang="en"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><title>Purl Rmd/*.Rmd to R/*.gen.R — purl_rmd • pkgpurl</title><script src="../lightswitch.js"></script><script src="../deps/jquery-3.6.0/jquery-3.6.0.min.js"></script><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><link href="../deps/bootstrap-5.3.1/bootstrap.min.css" rel="stylesheet"><script src="../deps/bootstrap-5.3.1/bootstrap.bundle.min.js"></script><link href="../deps/font-awesome-6.5.2/css/all.min.css" rel="stylesheet"><link href="../deps/font-awesome-6.5.2/css/v4-shims.min.css" rel="stylesheet"><script src="../deps/headroom-0.11.0/headroom.min.js"></script><script src="../deps/headroom-0.11.0/jQuery.headroom.min.js"></script><script src="../deps/bootstrap-toc-1.0.1/bootstrap-toc.min.js"></script><script src="../deps/clipboard.js-2.0.11/clipboard.min.js"></script><script src="../deps/search-1.0.0/autocomplete.jquery.min.js"></script><script src="../deps/search-1.0.0/fuse.min.js"></script><script src="../deps/search-1.0.0/mark.min.js"></script><!-- pkgdown --><script src="../pkgdown.js"></script><meta property="og:title" content="Purl Rmd/*.Rmd to R/*.gen.R — purl_rmd"><meta name="description" content="This function strives to provide a standardized way to convert all relevant .Rmd files in the Rmd/ subdirectory to bare .R files in the R/
subdirectory using knitr::purl(). It is mainly intended for authoring R packages in the R Markdown file format."><meta property="og:description" content="This function strives to provide a standardized way to convert all relevant .Rmd files in the Rmd/ subdirectory to bare .R files in the R/
subdirectory using knitr::purl(). It is mainly intended for authoring R packages in the R Markdown file format."><meta name="twitter:card" content="summary"><meta name="twitter:creator" content="@2BSalim"><meta name="twitter:site" content="@2BSalim"><meta name="robots" content="noindex"><script src="https://rpkg.dev/counter-dev.min.js" data-id="4c4963fe-9fcf-4d81-95bb-2135e114b85b" data-utcoffset="1"></script></head><body>
    <a href="#main" class="visually-hidden-focusable">Skip to contents</a>


    <nav class="navbar navbar-expand-lg fixed-top " aria-label="Site navigation"><div class="container">

    <a class="navbar-brand me-2" href="../index.html">pkgpurl</a>

    <small class="nav-text text-danger me-auto" data-bs-toggle="tooltip" data-bs-placement="bottom" title="In-development version">0.0.9015</small>


    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div id="navbar" class="collapse navbar-collapse ms-3">
      <ul class="navbar-nav me-auto"><li class="active nav-item"><a class="nav-link" href="../reference/index.html">Reference</a></li>
      </ul><ul class="navbar-nav"><li class="nav-item"><form class="form-inline" role="search">
 <input class="form-control" type="search" name="search-input" id="search-input" autocomplete="off" aria-label="Search site" placeholder="Search for" data-search-index="../search.json"></form></li>
<li class="nav-item"><a class="external-link nav-link" href="https://gitlab.com/rpkg.dev/pkgpurl/" aria-label="GitLab"><span class="fa fab fa-gitlab fa-lg"></span></a></li>
<li class="nav-item dropdown">
  <button class="nav-link dropdown-toggle" type="button" id="dropdown-lightswitch" data-bs-toggle="dropdown" aria-expanded="false" aria-haspopup="true" aria-label="Light switch"><span class="fa fa-sun"></span></button>
  <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="dropdown-lightswitch"><li><button class="dropdown-item" data-bs-theme-value="light"><span class="fa fa-sun"></span> Light</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="dark"><span class="fa fa-moon"></span> Dark</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="auto"><span class="fa fa-adjust"></span> Auto</button></li>
  </ul></li>
      </ul></div>


  </div>
</nav><div class="container template-reference-topic">
<div class="row">
  <main id="main" class="col-md-9"><div class="page-header">

      <h1>Purl <code>Rmd/*.Rmd</code> to <code>R/*.gen.R</code></h1>
      <small class="dont-index">Source: <a href="https://gitlab.com/rpkg.dev/pkgpurl/blob/HEAD/R/pkgpurl.gen.R" class="external-link"><code>R/pkgpurl.gen.R</code></a></small>
      <div class="d-none name"><code>purl_rmd.Rd</code></div>
    </div>

    <div class="ref-description section level2">
    <p>This function strives to provide a standardized way to convert all relevant <code>.Rmd</code> files in the <code>Rmd/</code> subdirectory to bare <code>.R</code> files in the <code>R/</code>
subdirectory using <code><a href="https://rdrr.io/pkg/knitr/man/knit.html" class="external-link">knitr::purl()</a></code>. It is mainly intended for authoring R packages in the <a href="https://rmarkdown.rstudio.com/" class="external-link">R Markdown file format</a>.</p>
    </div>

    <div class="section level2">
    <h2 id="ref-usage">Usage<a class="anchor" aria-label="anchor" href="#ref-usage"></a></h2>
    <div class="sourceCode"><pre class="sourceCode r"><code><span><span class="fu">purl_rmd</span><span class="op">(</span></span>
<span>  path <span class="op">=</span> <span class="st">"."</span>,</span>
<span>  add_copyright_notice <span class="op">=</span> <span class="fu">pal</span><span class="fu">::</span><span class="fu"><a href="https://pal.rpkg.dev/reference/pkg_config_val.html" class="external-link">pkg_config_val</a></span><span class="op">(</span><span class="st">"add_copyright_notice"</span><span class="op">)</span>,</span>
<span>  add_license_notice <span class="op">=</span> <span class="fu">pal</span><span class="fu">::</span><span class="fu"><a href="https://pal.rpkg.dev/reference/pkg_config_val.html" class="external-link">pkg_config_val</a></span><span class="op">(</span><span class="st">"add_license_notice"</span><span class="op">)</span>,</span>
<span>  gen_pkgdown_ref <span class="op">=</span> <span class="fu">pal</span><span class="fu">::</span><span class="fu"><a href="https://pal.rpkg.dev/reference/pkg_config_val.html" class="external-link">pkg_config_val</a></span><span class="op">(</span><span class="st">"gen_pkgdown_ref"</span><span class="op">)</span>,</span>
<span>  env <span class="op">=</span> <span class="fu"><a href="https://rdrr.io/r/base/sys.parent.html" class="external-link">parent.frame</a></span><span class="op">(</span><span class="op">)</span></span>
<span><span class="op">)</span></span></code></pre></div>
    </div>

    <div class="section level2">
    <h2 id="arguments">Arguments<a class="anchor" aria-label="anchor" href="#arguments"></a></h2>


<dl><dt id="arg-path">path<a class="anchor" aria-label="anchor" href="#arg-path"></a></dt>
<dd><p>Path to the root of the package directory.</p></dd>


<dt id="arg-add-copyright-notice">add_copyright_notice<a class="anchor" aria-label="anchor" href="#arg-add-copyright-notice"></a></dt>
<dd><p>Whether or not to add a <strong>copyright notice</strong> at the beginning of the generated <code>.R</code> files as recommended by e.g. the <a href="https://www.gnu.org/licenses/gpl-howto.html" class="external-link">GNU licenses</a>. The notice consists of the name and description of the program and the word <code>Copyright (C)</code> followed by the release years and the name(s) of the copyright holder(s), or if not specified, the author(s). The year is always the current year. All the other information is extracted from the package's <code>DESCRIPTION</code> file. A logical scalar. Only applies if <code>path</code> <a href="https://pal.rpkg.dev/reference/is_pkg_dir.html" class="external-link">is actually an R package directory</a>.</p></dd>


<dt id="arg-add-license-notice">add_license_notice<a class="anchor" aria-label="anchor" href="#arg-add-license-notice"></a></dt>
<dd><p>Whether or not to add a <strong>license notice</strong> at the beginning of the generated <code>.R</code> files as recommended by e.g. the <a href="https://www.gnu.org/licenses/gpl-howto.html" class="external-link">GNU licenses</a>. The license is determined from the package's <code>DESCRIPTION</code> file and currently only the <a href="https://spdx.org/licenses/AGPL-3.0-or-later.html" class="external-link"><code>AGPL-3.0-or-later</code> license</a> is supported. A logical scalar. Only applies if <code>path</code> <a href="https://pal.rpkg.dev/reference/is_pkg_dir.html" class="external-link">is actually an R package directory</a>.</p></dd>


<dt id="arg-gen-pkgdown-ref">gen_pkgdown_ref<a class="anchor" aria-label="anchor" href="#arg-gen-pkgdown-ref"></a></dt>
<dd><p>Whether or not to overwrite <a href="https://pkgdown.r-lib.org/" class="external-link">pkgdown</a>'s <a href="https://pkgdown.r-lib.org/reference/build_reference.html#reference-index" class="external-link">reference index</a> in the configuration file <code>_pkgdown.yml</code> with an auto-generated one based on the main input file as described in <code><a href="gen_pkgdown_ref.html">gen_pkgdown_ref()</a></code>. A logical scalar. Only applies if <code>path</code> <a href="https://pal.rpkg.dev/reference/is_pkg_dir.html" class="external-link">is actually an R package directory</a>, <a href="https://pal.rpkg.dev/reference/is_pkgdown_dir.html" class="external-link">pkgdown is set up</a> and a <a href="main_rmd.html">main R Markdown file</a> exists.</p></dd>


<dt id="arg-env">env<a class="anchor" aria-label="anchor" href="#arg-env"></a></dt>
<dd><p>Environment to evaluate R Markdown inline code expressions in when generating the pkgdown reference index. Only relevant if
<code>gen_pkgdown_ref = TRUE</code>.</p></dd>

</dl></div>
    <div class="section level2">
    <h2 id="value">Value<a class="anchor" aria-label="anchor" href="#value"></a></h2>
    <p><code>path</code>, invisibly.</p>
    </div>
    <div class="section level2">
    <h2 id="details">Details<a class="anchor" aria-label="anchor" href="#details"></a></h2>
    <p>The generated <code>.R</code> files will be named the same as the <code>.Rmd</code> files plus the suffix <code>.gen</code> to indicate the file was auto-generated. So the file
<code>Rmd/foo.Rmd</code> for example will be converted to <code>R/foo.gen.R</code>.</p>
<p>The R Markdown file format allows you to intermingle code with related prose in <a href="https://bookdown.org/yihui/rmarkdown/markdown-syntax.html" class="external-link">Markdown syntax</a>
optimized for human readability. This facilitates (best) practices which are commonly referred to as
<a href="https://en.wikipedia.org/wiki/Literate_programming" class="external-link"><em>literate programming</em></a>.</p>
<p>In practice, the main advantage of writing R code in R Markdown is that you don't have to rely on
<a href="https://cran.r-project.org/doc/manuals/r-release/R-lang.html#Comments" class="external-link"><code>#</code> comments</a> to explain, annotate or otherwise elaborate on your code. It also
allows you to easily compile your source code to beautifully looking HTML, PDF etc. files using <code><a href="https://pkgs.rstudio.com/rmarkdown/reference/render.html" class="external-link">rmarkdown::render()</a></code>.</p>
<p>This function is registered as an <a href="https://rstudio.github.io/rstudioaddins/" class="external-link">RStudio add-in</a>, allowing RStudio users to assign a <a href="https://support.rstudio.com/hc/en-us/articles/206382178-Customizing-Keyboard-Shortcuts-in-the-RStudio-IDE" class="external-link">custom shortcut</a> to it and to invoke it from the <a href="https://www.rstudio.com/blog/rstudio-1-4-a-quick-tour/#command-palette--shortcuts" class="external-link">command palette</a>.</p>
    </div>
    <div class="section level2">
    <h2 id="-rmd-files-excluded-from-purling"><code>.Rmd</code> files excluded from purling<a class="anchor" aria-label="anchor" href="#-rmd-files-excluded-from-purling"></a></h2>
    <p><code>purl_rmd()</code> does not generate an <code>.R</code> file for each and every R Markdown file in the <code>Rmd/</code> subdirectory. Two types of <code>.Rmd</code> files are excluded from
purling:</p><ol><li><p>Files having the suffix <code>.nopurl</code> in their name, e.g. <code>Rmd/playground.nopurl.Rmd</code>.</p></li>
<li><p>Hidden files <a href="https://en.wikipedia.org/wiki/Hidden_file_and_hidden_directory#Unix_and_Unix-like_environments" class="external-link">as per Unix convention</a> whose names start
with a dot, e.g. <code>Rmd/.playground.Rmd</code>.</p></li>
</ol><p>The above convention allows for easy exclusion of specific <code>.Rmd</code> files from purling. A common case for this are scripts that generate <a href="https://r-pkgs.org/data.html#sec-data-sysdata" class="external-link">package-internal data</a> from raw sources. Such a script could be stored as <code>Rmd/data.nopurl.Rmd</code>, so that no corresponding file
under <code>R/*.R</code> is generated. For the sake of clarity, it's generally advised to prefer the <code>.nopurl</code> suffix over hiding files.</p>
    </div>
    <div class="section level2">
    <h2 id="see-also">See also<a class="anchor" aria-label="anchor" href="#see-also"></a></h2>
    <div class="dont-index"><p>Other high-level functions:
<code><a href="lint_rmd.html">lint_rmd</a>()</code>,
<code><a href="load_pkg.html">load_pkg</a>()</code>,
<code><a href="process_pkg.html">process_pkg</a>()</code>,
<code><a href="run_nopurl_rmd.html">run_nopurl_rmd</a>()</code></p></div>
    </div>

  </main><aside class="col-md-3"><nav id="toc" aria-label="Table of contents"><h2>On this page</h2>
    </nav></aside></div>


    <footer><div class="pkgdown-footer-left">
  <p>Developed by Salim Brüggemann.</p>
</div>

<div class="pkgdown-footer-right">
  <p>Site built with <a href="https://pkgdown.r-lib.org/" class="external-link">pkgdown</a> 2.1.1.</p>
</div>

    </footer></div>





  </body></html>

